(document:surround "/std/frame")
(document:surround "/std/functions")
(document:envelop with-translation _ "alterator-users")

(define (write-user)
  (woo-catch/message
   (thunk
    (let ((passwd_1 (passwd_1 value))
          (passwd_2 (passwd_2 value))
          (passwd_auto (passwd_auto value))
          (auto (auto value))
          (account (account value)))
      (cond
	((string-null? account)
	 (if (pair? (woo-list "/users"))
	     'skip-step
	     (woo-throw (_ "You should define a system user"))))
	((or (and (not auto) (string-null? passwd_1))
	     (and auto (string-null? passwd_auto)))
	 (woo-throw (_ "You should define a password")))
	(else
	  (woo-new/constraints "/users"
			       'name account
			       'allow_su #t
			       'auto auto
			       'passwd_auto passwd_auto
			       'passwd_1 passwd_1
			       'passwd_2 passwd_2)))))))

(define (read-user)
  (woo-catch/message
    (thunk
      (let ((data (woo-read-first "/users")))
         (passwd_auto value (woo-get-option data 'passwd_auto))))))

;;;;;;;;;;;;;;;;;;;;;;;;;

(frame:on-next (thunk (or (write-user) 'cancel)))

;;; UI

(gridbox
  columns "20;0;60;20"
  ;;
  (spacer)
  (label text (_ "New user account") colspan 3)
  ;;
  (label colspan 4)
  ;;
  (spacer)
  (label text (_ "Name:") align "right")
  (document:id account (edit focus #t))
  (spacer)

  ;;
  (label colspan 4)

  ;;
  (spacer)
  (label text (_ "Password:") align "top;right")
  (gridbox
    columns "100;0"
    (document:id auto (checkbox text (_ "Generate automatically") name "auto"))
    (spacer)
    (document:id passwd_1 (edit name "passwd_1" echo "stars" visibility #f))
    (label name "passwd_1" text (small (_ "(enter passphrase)")) visibility #f)
    (document:id passwd_2 (edit name "passwd_2" echo "stars" visibility #f))
    (label name "passwd_1" text (small (_ "(repeat passphrase)")) visibility #f)
    (document:id passwd_auto (edit name "passwd_auto" visibility #f))
    (button text (_ "Generate") name "passwd_auto" visibility #f (when clicked (read-user)))
    (label colspan 2 name "passwd_auto" visibility #f))
  (spacer))

;;; Logic
(effect-show "passwd_1" "auto" #f)
(effect-show "passwd_2" "auto" #f)
(effect-show "passwd_auto" "auto" #t)

(document:root
  (when loaded
    (read-user)
    (init-effect)))
